## Main loop and Events Main loop and Events — Library initialization, main event loop, and events |

## Functions

gchar * | gtk_set_locale ()
void | gtk_disable_setlocale ()
PangoLanguage * | gtk_get_default_language ()
gboolean | gtk_parse_args ()
void | gtk_init ()
gboolean | gtk_init_check ()
gboolean | gtk_init_with_args ()
GOptionGroup * | gtk_get_option_group ()
void | gtk_exit ()
gboolean | gtk_events_pending ()
void | gtk_main ()
guint | gtk_main_level ()
void | gtk_main_quit ()
gboolean | gtk_main_iteration ()
gboolean | gtk_main_iteration_do ()
void | gtk_main_do_event ()
void | (*GtkModuleInitFunc) ()
void | (*GtkModuleDisplayInitFunc) ()
gboolean | gtk_true ()
gboolean | gtk_false ()
void | gtk_grab_add ()
GtkWidget * | gtk_grab_get_current ()
void | gtk_grab_remove ()
void | gtk_init_add ()
void | gtk_quit_add_destroy ()
guint | gtk_quit_add ()
guint | gtk_quit_add_full ()
void | gtk_quit_remove ()
void | gtk_quit_remove_by_data ()
guint | gtk_timeout_add_full ()
guint | gtk_timeout_add ()
void | gtk_timeout_remove ()
guint | gtk_idle_add ()
guint | gtk_idle_add_priority ()
guint | gtk_idle_add_full ()
void | gtk_idle_remove ()
void | gtk_idle_remove_by_data ()
guint | gtk_input_add_full ()
void | gtk_input_remove ()
#define | GTK_PRIORITY_REDRAW
#define | GTK_PRIORITY_RESIZE
guint | gtk_key_snooper_install ()
gint | (*GtkKeySnoopFunc) ()
void | gtk_key_snooper_remove ()
GdkEvent * | gtk_get_current_event ()
guint32 | gtk_get_current_event_time ()
gboolean | gtk_get_current_event_state ()
GtkWidget * | gtk_get_event_widget ()
void | gtk_propagate_event ()

## Types and Values

#define | GTK_PRIORITY_HIGH
#define | GTK_PRIORITY_INTERNAL
#define | GTK_PRIORITY_DEFAULT
#define | GTK_PRIORITY_LOW

## Includes

    #include <gtk/gtk.h>

## Description

Before using GTK+, you need to initialize it; initialization connects to the window system display, and parses some standard command line arguments. The `gtk_init()` function initializes GTK+. `gtk_init()` exits the application if errors occur; to avoid this, use `gtk_init_check()`. `gtk_init_check()` allows you to recover from a failed GTK+ initialization - you might start up your application in text mode instead.

Like all GUI toolkits, GTK+ uses an event-driven programming model. When the user is doing nothing, GTK+ sits in the main loop and waits for input. If the user performs some action - say, a mouse click - then the main loop "wakes up" and delivers an event to GTK+. GTK+ forwards the event to one or more widgets.

When widgets receive an event, they frequently emit one or more signals. Signals notify your program that "something interesting happened" by invoking functions you've connected to the signal with `g_signal_connect()`. Functions connected to a signal are often termed callbacks.

When your callbacks are invoked, you would typically take some action - for example, when an Open button is clicked you might display a GtkFileSelectionDialog. After a callback finishes, GTK+ will return to the main loop and await more user input.

Example 2. Typical `main` function for a GTK+ application

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    int
    main (int argc, char **argv)
    {
      /* Initialize i18n support */
      gtk_set_locale ();
      /* Initialize the widget set */
      gtk_init (&argc, &argv);
      /* Create the main window */
      mainwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      /* Set up our GUI elements */
      ...
      /* Show the application window */
      gtk_widget_show_all (mainwin);
      /* Enter the main event loop, and wait for user interaction */
      gtk_main ();
      /* The user lost interest */
      return 0;
    }

It's OK to use the GLib main loop directly instead of `gtk_main()`, though it involves slightly more typing. See GMainLoop in the GLib documentation.

## Functions

### gtk_set_locale ()

    gchar *
    gtk_set_locale (void);

`gtk_set_locale` has been deprecated since version 2.24 and should not be used in newly-written code.

Use `setlocale()` directly

Initializes internationalization support for GTK+. `gtk_init()` automatically does this, so there is typically no point in calling this function.

If you are calling this function because you changed the locale after GTK+ is was initialized, then calling this function may help a bit. (Note, however, that changing the locale after GTK+ is initialized may produce inconsistent results and is not really supported.)

In detail - sets the current locale according to the program environment. This is the same as calling the C library function `setlocale (LC_ALL, "")` but also takes care of the locale specific setup of the windowing system used by GDK.

#### Returns

a string corresponding to the locale set, typically in the form lang_COUNTRY, where lang is an ISO-639 language code, and COUNTRY is an ISO-3166 country code. On Unix, this form matches the result of the `setlocale()`; it is also used on other machines, such as Windows, where the C library returns a different result. The string is owned by GTK+ and should not be modified or freed.

### gtk_disable_setlocale ()

    void
    gtk_disable_setlocale (void);

`gtk_disable_setlocale` is deprecated and should not be used in newly-written code.

Prevents `gtk_init()`, `gtk_init_check()`, `gtk_init_with_args()` and `gtk_parse_args()` from automatically calling `setlocale (LC_ALL, "")`. You would want to use this function if you wanted to set the locale for your program to something other than the user's locale, or if you wanted to set different values for different locale categories.

Most programs should not need to call this function.

### gtk_get_default_language ()

    PangoLanguage *
    gtk_get_default_language (void);

Returns the PangoLanguage for the default language currently in effect. (Note that this can change over the life of an application.) The default language is derived from the current locale. It determines, for example, whether GTK+ uses the right-to-left or left-to-right text direction.

This function is equivalent to `pango_language_get_default()`. See that function for details.

#### Returns

the default language as a PangoLanguage, must not be freed

### gtk_parse_args ()

    gboolean
    gtk_parse_args (int *argc,
                    char ***argv);

Parses command line arguments, and initializes global attributes of GTK+, but does not actually open a connection to a display. (See `gdk_display_open()`, `gdk_get_display_arg_name()`)

Any arguments used by GTK+ or GDK are removed from the array and `argc` and `argv` are updated accordingly.

There is no need to call this function explicitely if you are using `gtk_init()`, or `gtk_init_check()`.

#### Parameters

argc | a pointer to the number of command line arguments. | [inout]
argv | a pointer to the array of command line arguments. | [array length=argc][inout]

#### Returns

`TRUE` if initialization succeeded, otherwise `FALSE`.

### gtk_init ()

    void
    gtk_init (int *argc,
              char ***argv);

Call this function before using any other GTK+ functions in your GUI applications. It will initialize everything needed to operate the toolkit and parses some standard command line options.

`argc` and `argv` are adjusted accordingly so your own code will never see those standard arguments.

Note that there are some alternative ways to initialize GTK+: if you are calling `gtk_parse_args()`, `gtk_init_check()`, `gtk_init_with_args()` or `g_option_context_parse()` with the option group returned by `gtk_get_option_group()`, you don't have to call `gtk_init()`.

This function will terminate your program if it was unable to initialize the windowing system for some reason. If you want your program to fall back to a textual interface you want to call `gtk_init_check()` instead.

Since 2.18, GTK+ calls `signal (SIGPIPE, SIG_IGN)` during initialization, to ignore SIGPIPE signals, since these are almost never wanted in graphical applications. If you do need to handle SIGPIPE for some reason, reset the handler after `gtk_init()`, but notice that other libraries (e.g. libdbus or gvfs) might do similar things.

#### Parameters

argc | Address of the `argc` parameter of your `main()` function. Changed if any arguments were handled. | [inout]
argv | Address of the `argv` parameter of `main()`. Any options understood by GTK+ are stripped before return. | [array length=argc][inout][allow-none]

### gtk_init_check ()

    gboolean
    gtk_init_check (int *argc,
                    char ***argv);

This function does the same work as `gtk_init()` with only a single change: It does not terminate the program if the GUI can't be initialized. Instead it returns `FALSE` on failure.

This way the application can fall back to some other means of communication with the user - for example a curses or command line interface.

#### Parameters

argc | Address of the `argc` parameter of your `main()` function. Changed if any arguments were handled. | [inout]
argv | Address of the `argv` parameter of `main()`. Any parameters understood by `gtk_init()` are stripped before return. | [array length=argc][inout][allow-none]

#### Returns

`TRUE` if the GUI has been successfully initialized, `FALSE` otherwise.

### gtk_init_with_args ()

    gboolean
    gtk_init_with_args (int *argc,
                        char ***argv,
                        const char *parameter_string,
                        GOptionEntry *entries,
                        const char *translation_domain,
                        GError **error);

This function does the same work as `gtk_init_check()`. Additionally, it allows you to add your own commandline options, and it automatically generates nicely formatted `--help` output. Note that your program will be terminated after writing out the help output.

#### Parameters

argc | a pointer to the number of command line arguments. |
argv | a pointer to the array of command line arguments. | [inout][array length=argc]
parameter_string | a string which is displayed in the first line of `--help` output, after ``programname` [OPTION...]` |
entries | a `NULL`-terminated array of GOptionEntrys describing the options of your program. | [array zero-terminated=1]
translation_domain | a translation domain to use for translating the `--help` output for the options in `entries` with `gettext()`, or `NULL` |
error | a return location for errors |

#### Returns

`TRUE` if the GUI has been successfully initialized, `FALSE` otherwise.

Since 2.6

### gtk_get_option_group ()

    GOptionGroup *
    gtk_get_option_group (gboolean open_default_display);

Returns a GOptionGroup for the commandline arguments recognized by GTK+ and GDK. You should add this group to your GOptionContext with `g_option_context_add_group()`, if you are using `g_option_context_parse()` to parse your commandline arguments.

#### Parameters

open_default_display | whether to open the default display when parsing the commandline arguments |

#### Returns

a GOptionGroup for the commandline arguments recognized by GTK+

Since 2.6

### gtk_exit ()

    void
    gtk_exit (gint error_code);

`gtk_exit` is deprecated and should not be used in newly-written code.

Use the standard `exit()` function instead.

Terminates the program and returns the given exit code to the caller. This function will shut down the GUI and free all resources allocated for GTK+.

#### Parameters

error_code | Return value to pass to the caller. This is dependent on the target system but at least on Unix systems `0` means success. |

### gtk_events_pending ()

    gboolean
    gtk_events_pending (void);

Checks if any events are pending. This can be used to update the GUI and invoke timeouts etc. while doing some time intensive computation.

Example 3. Updating the GUI during a long computation.

    1
    2
    3
    4
    5
    6
    /* computation going on */
    ...
            while (gtk_events_pending ())
      gtk_main_iteration ();
    ...
    /* computation continued */

#### Returns

`TRUE` if any events are pending, `FALSE` otherwise.

### gtk_main ()

    void
    gtk_main (void);

Runs the main loop until `gtk_main_quit()` is called. You can nest calls to `gtk_main()`. In that case `gtk_main_quit()` will make the innermost invocation of the main loop return.

### gtk_main_level ()

    guint
    gtk_main_level (void);

Asks for the current nesting level of the main loop. This can be useful when calling `gtk_quit_add()`.

#### Returns

the nesting level of the current invocation of the main loop.

### gtk_main_quit ()

    void
    gtk_main_quit (void);

Makes the innermost invocation of the main loop return when it regains control.

### gtk_main_iteration ()

    gboolean
    gtk_main_iteration (void);

Runs a single iteration of the mainloop. If no events are waiting to be processed GTK+ will block until the next event is noticed. If you don't want to block look at `gtk_main_iteration_do()` or check if any events are pending with `gtk_events_pending()` first.

#### Returns

`TRUE` if `gtk_main_quit()` has been called for the innermost mainloop.

### gtk_main_iteration_do ()

    gboolean
    gtk_main_iteration_do (gboolean blocking);

Runs a single iteration of the mainloop. If no events are available either return or block dependent on the value of `blocking`.

#### Parameters

blocking | `TRUE` if you want GTK+ to block if no events are pending. |

#### Returns

`TRUE` if `gtk_main_quit()` has been called for the innermost mainloop.

### gtk_main_do_event ()

    void
    gtk_main_do_event (GdkEvent *event);

Processes a single GDK event. This is public only to allow filtering of events between GDK and GTK+. You will not usually need to call this function directly.

While you should not call this function directly, you might want to know how exactly events are handled. So here is what this function does with the event:

1. Compress enter/leave notify events. If the event passed build an enter/leave pair together with the next event (peeked from GDK) both events are thrown away. This is to avoid a backlog of (de-)highlighting widgets crossed by the pointer.

2. Find the widget which got the event. If the widget can't be determined the event is thrown away unless it belongs to a INCR transaction. In that case it is passed to `gtk_selection_incr_event()`.

3. Then the event is passed on a stack so you can query the currently handled event with `gtk_get_current_event()`.

4. The event is sent to a widget. If a grab is active all events for widgets that are not in the contained in the grab widget are sent to the latter with a few exceptions:

   - Deletion and destruction events are still sent to the event widget for obvious reasons.

   - Events which directly relate to the visual representation of the event widget.

   - Leave events are delivered to the event widget if there was an enter event delivered to it before without the paired leave event.

   - Drag events are not redirected because it is unclear what the semantics of that would be.

   Another point of interest might be that all key events are first passed through the key snooper functions if there are any. Read the description of `gtk_key_snooper_install()` if you need this feature.

5. After finishing the delivery the event is popped from the event stack.

#### Parameters

event | An event to process (normally) passed by GDK. |

### GtkModuleInitFunc ()

    void
    (*GtkModuleInitFunc) (gint *argc,
                          gchar ***argv);

Each GTK+ module must have a function `gtk_module_init()` with this prototype. This function is called after loading the module with the `argc` and `argv` cleaned from any arguments that GTK+ handles itself.

#### Parameters

argc | Pointer to the number of arguments remaining after `gtk_init()`. |
argv | Points to the argument vector. |

### GtkModuleDisplayInitFunc ()

    void
    (*GtkModuleDisplayInitFunc) (GdkDisplay *display);

Since 2.2

### gtk_true ()

    gboolean
    gtk_true (void);

All this function does it to return `TRUE`. This can be useful for example if you want to inhibit the deletion of a window. Of course you should not do this as the user expects a reaction from clicking the close icon of the window...

Example 4. A persistent window

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    ##include <gtk/gtk.h>
    int
    main (int argc, char **argv)
    {
      GtkWidget     *win, *but;
      gtk_init( &argc, &argv );
      win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      g_signal_connect (win, "delete-event",
                        G_CALLBACK (gtk_true), NULL);
      g_signal_connect (win, "destroy",
                G_CALLBACK (gtk_main_quit), NULL);
      but = gtk_button_new_with_label ("Close yourself. I mean it!");
      g_signal_connect_swapped (but, "clicked",
              G_CALLBACK (gtk_object_destroy), win);
      gtk_container_add (GTK_CONTAINER (win), but);
      gtk_widget_show_all (win);
      gtk_main ();
      return 0;
    }

#### Returns

`TRUE`

### gtk_false ()

    gboolean
    gtk_false (void);

Analogical to `gtk_true()` this function does nothing but always returns `FALSE`.

#### Returns

`FALSE`

### gtk_grab_add ()

    void
    gtk_grab_add (GtkWidget *widget);

Makes `widget` the current grabbed widget. This means that interaction with other widgets in the same application is blocked and mouse as well as keyboard events are delivered to this widget.

If `widget` is not sensitive, it is not set as the current grabbed widget and this function does nothing.

#### Parameters

widget | The widget that grabs keyboard and pointer events. |

### gtk_grab_get_current ()

    GtkWidget *
    gtk_grab_get_current (void);

Queries the current grab of the default window group.

Queries the current grab of the default window group.

#### Returns

The widget which currently has the grab or `NULL` if no grab is active.

[transfer none]

### gtk_grab_remove ()

    void
    gtk_grab_remove (GtkWidget *widget);

Removes the grab from the given widget. You have to pair calls to `gtk_grab_add()` and `gtk_grab_remove()`.

If `widget` does not have the grab, this function does nothing.

#### Parameters

widget | The widget which gives up the grab. |

### gtk_init_add ()

    void
    gtk_init_add (GtkFunction function,
                  gpointer data);

`gtk_init_add` is deprecated and should not be used in newly-written code.

This function is going to be removed in GTK+ 3.0

Registers a function to be called when the mainloop is started.

#### Parameters

function | Function to invoke when `gtk_main()` is called next. |
data | Data to pass to that function. |

### gtk_quit_add_destroy ()

    void
    gtk_quit_add_destroy (guint main_level,
                          GtkObject *object);

`gtk_quit_add_destroy` is deprecated and should not be used in newly-written code.

This function is going to be removed in GTK+ 3.0

Trigger destruction of `object` in case the mainloop at level `main_level` is quit.

#### Parameters

main_level | Level of the mainloop which shall trigger the destruction. |
object | Object to be destroyed. |

### gtk_quit_add ()

    guint
    gtk_quit_add (guint main_level,
                  GtkFunction function,
                  gpointer data);

`gtk_quit_add` is deprecated and should not be used in newly-written code.

This function is going to be removed in GTK+ 3.0

Registers a function to be called when an instance of the mainloop is left.

#### Parameters

main_level | Level at which termination the function shall be called. You can pass 0 here to have the function run at the termination of the current mainloop. |
function | The function to call. This should return 0 to be removed from the list of quit handlers. Otherwise the function might be called again. |
data | Pointer to pass when calling `function` . |

#### Returns

A handle for this quit handler (you need this for `gtk_quit_remove()`) or 0 if you passed a `NULL` pointer in `function` .

### gtk_quit_add_full ()

    guint
    gtk_quit_add_full (guint main_level,
                       GtkFunction function,
                       GtkCallbackMarshal marshal,
                       gpointer data,
                       GDestroyNotify destroy);

`gtk_quit_add_full` is deprecated and should not be used in newly-written code.

This function is going to be removed in GTK+ 3.0

Registers a function to be called when an instance of the mainloop is left. In comparison to `gtk_quit_add()` this function adds the possibility to pass a marshaller and a function to be called when the quit handler is freed.

The former can be used to run interpreted code instead of a compiled function while the latter can be used to free the information stored in `data` (while you can do this in `function` as well)... So this function will mostly be used by GTK+ wrappers for languages other than C.

#### Parameters

main_level | Level at which termination the function shall be called. You can pass 0 here to have the function run at the termination of the current mainloop. |
function | The function to call. This should return 0 to be removed from the list of quit handlers. Otherwise the function might be called again. |
marshal | The marshaller to be used. If this is non-`NULL`, `function` is ignored. |
data | Pointer to pass when calling `function` . |
destroy | Function to call to destruct `data` . Gets `data` as argument. |

#### Returns

A handle for this quit handler (you need this for `gtk_quit_remove()`) or 0 if you passed a `NULL` pointer in `function` .

### gtk_quit_remove ()

    void
    gtk_quit_remove (guint quit_handler_id);

`gtk_quit_remove` is deprecated and should not be used in newly-written code.

This function is going to be removed in GTK+ 3.0

Removes a quit handler by its identifier.

#### Parameters

quit_handler_id | Identifier for the handler returned when installing it. |

### gtk_quit_remove_by_data ()

    void
    gtk_quit_remove_by_data (gpointer data);

`gtk_quit_remove_by_data` is deprecated and should not be used in newly-written code.

This function is going to be removed in GTK+ 3.0

Removes a quit handler identified by its `data` field.

#### Parameters

data | The pointer passed as `data` to `gtk_quit_add()` or `gtk_quit_add_full()`. |

### gtk_timeout_add_full ()

    guint
    gtk_timeout_add_full (guint32 interval,
                          GtkFunction function,
                          GtkCallbackMarshal marshal,
                          gpointer data,
                          GDestroyNotify destroy);

`gtk_timeout_add_full` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_timeout_add_full()` instead.

Registers a function to be called periodically. The function will be called repeatedly after `interval` milliseconds until it returns `FALSE` at which point the timeout is destroyed and will not be called again.

#### Parameters

interval | The time between calls to the function, in milliseconds (1/1000ths of a second.) |
function | The function to call periodically. |
marshal | The marshaller to use instead of the function (if non-`NULL`). |
data | The data to pass to the function. |
destroy | Function to call when the timeout is destroyed or `NULL`. |

#### Returns

A unique id for the event source.

### gtk_timeout_add ()

    guint
    gtk_timeout_add (guint32 interval,
                     GtkFunction function,
                     gpointer data);

`gtk_timeout_add` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_timeout_add()` instead.

Registers a function to be called periodically. The function will be called repeatedly after `interval` milliseconds until it returns `FALSE` at which point the timeout is destroyed and will not be called again.

#### Parameters

interval | The time between calls to the function, in milliseconds (1/1000ths of a second.) |
function | The function to call periodically. |
data | The data to pass to the function. |

#### Returns

A unique id for the event source.

### gtk_timeout_remove ()

    void
    gtk_timeout_remove (guint timeout_handler_id);

`gtk_timeout_remove` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_source_remove()` instead.

Removes the given timeout destroying all information about it.

#### Parameters

timeout_handler_id | The identifier returned when installing the timeout. |

### gtk_idle_add ()

    guint
    gtk_idle_add (GtkFunction function,
                  gpointer data);

`gtk_idle_add` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_idle_add()` instead.

Causes the mainloop to call the given function whenever no events with higher priority are to be processed. The default priority is `GTK_PRIORITY_DEFAULT`, which is rather low.

#### Parameters

function | The function to call. |
data | The information to pass to the function. |

#### Returns

a unique handle for this registration.

### gtk_idle_add_priority ()

    guint
    gtk_idle_add_priority (gint priority,
                           GtkFunction function,
                           gpointer data);

`gtk_idle_add_priority` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_idle_add_full()` instead.

Like `gtk_idle_add()` this function allows you to have a function called when the event loop is idle. The difference is that you can give a priority different from `GTK_PRIORITY_DEFAULT` to the idle function.

#### Parameters

priority | The priority which should not be above `G_PRIORITY_HIGH_IDLE`. Note that you will interfere with GTK+ if you use a priority above `GTK_PRIORITY_RESIZE`. |
function | The function to call. |
data | Data to pass to that function. |

#### Returns

A unique id for the event source.

### gtk_idle_add_full ()

    guint
    gtk_idle_add_full (gint priority,
                       GtkFunction function,
                       GtkCallbackMarshal marshal,
                       gpointer data,
                       GDestroyNotify destroy);

`gtk_idle_add_full` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_idle_add_full()` instead.

Like `gtk_idle_add()` this function allows you to have a function called when the event loop is idle. The difference is that you can give a priority different from `GTK_PRIORITY_DEFAULT` to the idle function.

#### Parameters

priority | The priority which should not be above `G_PRIORITY_HIGH_IDLE`. Note that you will interfere with GTK+ if you use a priority above `GTK_PRIORITY_RESIZE`. |
function | The function to call. |
marshal | The marshaller to use instead of the function (if non-`NULL`). |
data | Data to pass to that function. |
destroy | Function to call when the timeout is destroyed or `NULL`. |

#### Returns

A unique id for the event source.

### gtk_idle_remove ()

    void
    gtk_idle_remove (guint idle_handler_id);

`gtk_idle_remove` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_source_remove()` instead.

Removes the idle function with the given id.

#### Parameters

idle_handler_id | Identifies the idle function to remove. |

### gtk_idle_remove_by_data ()

    void
    gtk_idle_remove_by_data (gpointer data);

`gtk_idle_remove_by_data` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_idle_remove_by_data()` instead.

Removes the idle function identified by the user data.

#### Parameters

data | remove the idle function which was registered with this user data. |

### gtk_input_add_full ()

    guint
    gtk_input_add_full (gint source,
                        GdkInputCondition condition,
                        GdkInputFunction function,
                        GtkCallbackMarshal marshal,
                        gpointer data,
                        GDestroyNotify destroy);

`gtk_input_add_full` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_io_add_watch_full()` instead.

Registers a function to be called when a condition becomes true on a file descriptor.

#### Parameters

source | a file descriptor. |
condition | the condition. |
function | The function to call. |
marshal | The marshaller to use instead of the function (if non-`NULL`). |
data | callback data passed to `function` . |
destroy | callback function to call with `data` when the input handler is removed, or `NULL`. |

#### Returns

A unique id for the event source; to be used with `gtk_input_remove()`.

### gtk_input_remove ()

    void
    gtk_input_remove (guint input_handler_id);

`gtk_input_remove` has been deprecated since version 2.4 and should not be used in newly-written code.

Use `g_source_remove()` instead.

Removes the function with the given id.

#### Parameters

input_handler_id | Identifies the function to remove. |

### GTK_PRIORITY_REDRAW

    #define GTK_PRIORITY_REDRAW     (G_PRIORITY_HIGH_IDLE + 20)

`GTK_PRIORITY_REDRAW` has been deprecated since version 2.4 and should not be used in newly-written code.

This macro is deprecated. You should use `GDK_PRIORITY_REDRAW` instead.

Use this priority for redrawing related stuff. It is used internally by GTK+ to do pending redraws. This priority is lower than `GTK_PRIORITY_RESIZE` to avoid redrawing a widget just before resizing (and therefore redrawing it again).

### GTK_PRIORITY_RESIZE

    #define GTK_PRIORITY_RESIZE     (G_PRIORITY_HIGH_IDLE + 10)

Use this priority for resizing related stuff. It is used internally by GTK+ to compute the sizes of widgets. This priority is higher than `GTK_PRIORITY_REDRAW` to avoid resizing a widget which was just redrawn.

### gtk_key_snooper_install ()

    guint
    gtk_key_snooper_install (GtkKeySnoopFunc snooper,
                             gpointer func_data);

`gtk_key_snooper_install` is deprecated and should not be used in newly-written code.

Installs a key snooper function, which will get called on all key events before delivering them normally.

#### Parameters

snooper | a GtkKeySnoopFunc. |
func_data | data to pass to `snooper` . |

#### Returns

a unique id for this key snooper for use with `gtk_key_snooper_remove()`.

### GtkKeySnoopFunc ()

    gint
    (*GtkKeySnoopFunc) (GtkWidget *grab_widget,
                        GdkEventKey *event,
                        gpointer func_data);

`GtkKeySnoopFunc` is deprecated and should not be used in newly-written code.

Key snooper functions are called before normal event delivery. They can be used to implement custom key event handling.

#### Parameters

grab_widget | the widget to which the event will be delivered. |
event | the key event. |
func_data | the `func_data` supplied to `gtk_key_snooper_install()`. |

#### Returns

`TRUE` to stop further processing of `event` , `FALSE` to continue.

### gtk_key_snooper_remove ()

    void
    gtk_key_snooper_remove (guint snooper_handler_id);

Removes the key snooper function with the given id.

#### Parameters

snooper_handler_id | Identifies the key snooper to remove. |

### gtk_get_current_event ()

    GdkEvent *
    gtk_get_current_event (void);

Obtains a copy of the event currently being processed by GTK+. For example, if you get a "clicked" signal from GtkButton, the current event will be the GdkEventButton that triggered the "clicked" signal. The returned event must be freed with `gdk_event_free()`. If there is no current event, the function returns `NULL`.

#### Returns

a copy of the current event, or `NULL` if no current event.

[transfer full]

### gtk_get_current_event_time ()

    guint32
    gtk_get_current_event_time (void);

If there is a current event and it has a timestamp, return that timestamp, otherwise return `GDK_CURRENT_TIME`.

#### Returns

the timestamp from the current event, or `GDK_CURRENT_TIME`.

### gtk_get_current_event_state ()

    gboolean
    gtk_get_current_event_state (GdkModifierType *state);

If there is a current event and it has a state field, place that state field in `state` and return `TRUE`, otherwise return `FALSE`.

#### Parameters

state | a location to store the state of the current event. | [out]

#### Returns

`TRUE` if there was a current event and it had a state field

### gtk_get_event_widget ()

    GtkWidget *
    gtk_get_event_widget (GdkEvent *event);

If `event` is `NULL` or the event was not associated with any widget, returns `NULL`, otherwise returns the widget that received the event originally.

#### Parameters

event | a GdkEvent |

#### Returns

the widget that originally received `event` , or `NULL`.

[transfer none]

### gtk_propagate_event ()

    void
    gtk_propagate_event (GtkWidget *widget,
                         GdkEvent *event);

Sends an event to a widget, propagating the event to parent widgets if the event remains unhandled. Events received by GTK+ from GDK normally begin in `gtk_main_do_event()`. Depending on the type of event, existence of modal dialogs, grabs, etc., the event may be propagated; if so, this function is used. `gtk_propagate_event()` calls `gtk_widget_event()` on each widget it decides to send the event to. So `gtk_widget_event()` is the lowest-level function; it simply emits the "event" and possibly an event-specific signal on a widget. `gtk_propagate_event()` is a bit higher-level, and `gtk_main_do_event()` is the highest level.

All that said, you most likely don't want to use any of these functions; synthesizing events is rarely needed. Consider asking on the mailing list for better ways to achieve your goals. For example, use `gdk_window_invalidate_rect()` or `gtk_widget_queue_draw()` instead of making up expose events.

#### Parameters

widget | a GtkWidget |
event | an event |

## Types and Values

### GTK_PRIORITY_HIGH

    #define GTK_PRIORITY_HIGH       G_PRIORITY_HIGH

`GTK_PRIORITY_HIGH` has been deprecated since version 2.4 and should not be used in newly-written code.

This macro is deprecated. You should use `G_PRIORITY_HIGH` instead.

Use this for high priority timeouts. This priority is never used inside GTK+ so everything running at this priority will be running before anything inside the toolkit.

### GTK_PRIORITY_INTERNAL

    #define GTK_PRIORITY_INTERNAL   GTK_PRIORITY_REDRAW

`GTK_PRIORITY_INTERNAL` is deprecated and should not be used in newly-written code.

This priority is for GTK+ internal stuff. Don't use it in your applications.

### GTK_PRIORITY_DEFAULT

    #define GTK_PRIORITY_DEFAULT G_PRIORITY_DEFAULT_IDLE

`GTK_PRIORITY_DEFAULT` has been deprecated since version 2.4 and should not be used in newly-written code.

This macro is deprecated. You should use `G_PRIORITY_DEFAULT_IDLE` instead.

Default priority for idle functions.

### GTK_PRIORITY_LOW

    #define GTK_PRIORITY_LOW G_PRIORITY_LOW

`GTK_PRIORITY_LOW` has been deprecated since version 2.4 and should not be used in newly-written code.

This macro is deprecated. You should use `G_PRIORITY_LOW` instead.

Priority for very unimportant background tasks.

## See Also

See the GLib manual, especially GMainLoop and signal-related functions such as `g_signal_connect()`.